package model;

import java.util.ArrayList;
import java.util.List;

public class CalculatorThread<Item> implements Runnable{
    private final List<CalculatorThread<Item>> calculators;
    private final Operation<Item> operation;
    private final int j;
    private final ArrayList<Item> items;
    private Item  it;
    private final int lastResultIndex;

    public CalculatorThread(List<CalculatorThread<Item>> calculators, Operation<Item> operation, int j, Item it) {
            this.calculators = calculators;
            this.items = new ArrayList<>();
            this.items.add(it);
            this.operation = operation;
            this.j = j;
            this.it = it;
            this.lastResultIndex = floor_log2(j + 1);
    }

    public int floor_log2(int i) {
            int j = 0, k = 1;
            while (k < i) {
                    j++;
                    k = k * 2;
            }
            return j;
    }

    public int min(int a, int b) {
            return (a < b) ? a : b;
    }

    public Item getResult(int iteration) {
            synchronized (items) {

                    while (items.size() - 1 < min(iteration, lastResultIndex))
                            try { items.wait(100); } catch (InterruptedException e) {}
                    return items.get(min(iteration, lastResultIndex));
            }
    }

    public void saveResult(Item it) {
            synchronized (items) {
                    items.add(it);
                    items.notifyAll();			
            }
    }

    @Override
    public void run() {
        int distance = 1;
        int iteration = 0;
        while (j - distance >= 0) {
                Item b = calculators.get(j - distance).getResult(iteration++);
                it = operation.add(it, b);
                saveResult(it);
                distance *= 2;
        }
        Display.display(j, items.get(lastResultIndex));
    }
}
